/* hangul.h */

#ifndef _HANGUL_H
#define _HANGUL_H

#include <stdio.h>
#include "convert.h"

#ifdef __cplusplus
extern "C" {
#endif

#undef TRUE 
#define TRUE 				1
#undef FALSE
#define FALSE 				0

#define IS_LOW_ASC			0	/* 127  ƽŰ ڵ      */ 
#define IS_HIGH_ASC 		1	/* 128 ̻ ƽŰ ڵ      */ 
#define IS_ENGLISH			0	/*  Ʈ ڵ        */
#define IS_HANGUL_FIRST  	1	/*  Ʈ ѱ ù°ڵ */
#define IS_HANGUL_SECOND 	2	/*  Ʈ ѱ °ڵ */

#define HAN_ENG_MODE 		0	/* ѱۿ Է 迭÷ */
#define HAN_KEYBOARD 		1	/* ι-  迭÷ */
#define HAN_CODE 			2	/* -ϼ Է» 迭÷ */

#define ENG_INPUT 			0	/*  Է */
#define HAN_INPUT 			1	/* ѱԷ */ 
#define DUBEL_TYPE 			0	/* ι */
#define SEBEL_TYPE 			1	/*  */
#define KS5061_CODE 		0	/* ϼ */
#define JOHAP_CODE 			1	/*  */

/* ѱǺƾ ϴ ũ  */
#define CODE_ENGLISH 		0	/*  ڵ */
#define CODE_KS5061 		1	/* ϼ ڵ */
#define CODE_JOHAP 			2	/*  ڵ */

/* Hangul Automata buffer structure */
struct inStack {
  int currentHanState;
  int key;
  int unionCode;
};

/* Variable about hangul Automata */
extern struct inStack inStack[];
extern int outStack[];
extern int inSP;
extern int outSP;
extern int tempHanState;

/* hangul or english, keyboard type, ks5601 or Johap code */
extern int hanMode[];

#define hanAutomata(x) (hanMode[HAN_KEYBOARD]?hanAutomata3(x):hanAutomata2(x))
#define hgetkey(x)     (hanMode[HAN_KEYBOARD]?hgetkey3(x):hgetkey2(x))

/* hangul input functions */
int hanAutomata2(int key);
int hanAutomata3(int key);

int hgetkey2(int *key);
int hgetkey3(int *key);

/* hangul etc functions */
int ishangul(unsigned char *str, int index);

#ifdef __cplusplus
}
#endif

#endif  /* hangul.h */
